VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form Form1 
   Caption         =   "USB - USART Emulation Demo v0.1"
   ClientHeight    =   2280
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4095
   LinkTopic       =   "Form1"
   ScaleHeight     =   2280
   ScaleWidth      =   4095
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame3 
      Caption         =   "Voltage Level"
      Height          =   735
      Left            =   2400
      TabIndex        =   8
      Top             =   1080
      Width           =   1575
      Begin VB.TextBox Voltvalue 
         Alignment       =   2  'Center
         Height          =   375
         Left            =   240
         Locked          =   -1  'True
         TabIndex        =   9
         Text            =   "0.00V"
         Top             =   240
         Width           =   1095
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "LED Toggle"
      Height          =   735
      Left            =   120
      TabIndex        =   5
      Top             =   1080
      Width           =   2175
      Begin VB.CheckBox LED3 
         Caption         =   "LED 3"
         Height          =   375
         Left            =   1080
         TabIndex        =   7
         Top             =   240
         Width           =   855
      End
      Begin VB.CheckBox LED2 
         Caption         =   "LED 2 "
         Height          =   375
         Left            =   120
         TabIndex        =   6
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Connect"
      Height          =   375
      Left            =   2400
      TabIndex        =   4
      Top             =   600
      Width           =   1575
   End
   Begin VB.Frame Frame1 
      Caption         =   "Virtual COM Port #"
      Height          =   855
      Left            =   120
      TabIndex        =   2
      ToolTipText     =   "Virtual COM Port is the COM Port created when the device is attached. Look for it in System in Control Panel under Device Manager."
      Top             =   120
      Width           =   2175
      Begin MSComctlLib.Slider Slider1 
         Height          =   495
         Left            =   120
         TabIndex        =   3
         ToolTipText     =   "Virtual COM Port is the COM Port created when the device is attached. Look for it in System in Control Panel under Device Manager."
         Top             =   240
         Width           =   1935
         _ExtentX        =   3413
         _ExtentY        =   873
         _Version        =   393216
         Min             =   1
         SelStart        =   1
         Value           =   1
      End
   End
   Begin VB.TextBox Text1 
      Alignment       =   2  'Center
      Height          =   285
      Left            =   2400
      Locked          =   -1  'True
      TabIndex        =   1
      Text            =   "1"
      Top             =   240
      Width           =   1575
   End
   Begin MSComctlLib.ProgressBar VoltBar 
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   1920
      Width           =   3855
      _ExtentX        =   6800
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
      Max             =   5120
      Scrolling       =   1
   End
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   3600
      Top             =   1800
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   3000
      Top             =   1680
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Menu Exit 
      Caption         =   "Exit"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim VCP As Integer
Dim Delay As Double
Dim RxData() As Byte
Dim Voltage As Single

Private Sub Command1_Click()

On Error GoTo ErrorHandler

If MSComm1.PortOpen = True Then
MSComm1.PortOpen = False
Text1.Text = "Offline"
Command1.Caption = "Connect"

Else
    MSComm1.CommPort = VCP
    'MSComm1.Settings = "115200, N, 8, 1"   'This line is omitted since the USB drivers will take over.
    MSComm1.InputLen = 0                    'Read all characters/bytes whenever Input property is used.
    MSComm1.InputMode = comInputModeBinary  'Input will retrieve binary data in array of Bytes.
    MSComm1.PortOpen = True                 'Open Serial Port COM1.

    MSComm1.Output = "T"                    'Talk to the PIC.
    
    Delay = Timer()                         'Give alittle time for PIC to reply.
    While Timer() - Delay < 0.1
    Wend
    
    If MSComm1.InBufferCount <> 0 Then      'Check if PIC replied.
        RxData() = MSComm1.Input
        If RxData(0) = &H58 Then            'Did PIC say "X" for acknowledge?
        Text1.Text = "Detected"             'If yes, then we found the device.
        Command1.Caption = "Disconnect"
        End If
    Else
    Text1.Text = "Not Detected"             'If not, we didn't find the PIC in this VCP.
    MSComm1.PortOpen = False
    End If
End If
Exit Sub

ErrorHandler:
    MsgBox "The following error has occured:" & vbCrLf & Err.Description

End Sub

Private Sub Exit_Click()
End
End Sub

Private Sub Form_Load()
VCP = 1
End Sub

Private Sub LED2_Click()
If MSComm1.PortOpen = True Then
    If LED2.Value = 1 Then
    MSComm1.Output = "W"
    Else
    MSComm1.Output = "Q"
    End If
End If
End Sub

Private Sub LED3_Click()
If MSComm1.PortOpen = True Then
    If LED3.Value = 1 Then
    MSComm1.Output = "S"
    Else
    MSComm1.Output = "A"
    End If
End If
End Sub

Private Sub Slider1_Scroll()
VCP = Slider1.Value
Text1.Text = Slider1.Value
End Sub

Private Sub Timer1_Timer()
If MSComm1.PortOpen = True Then
   MSComm1.Output = "C"
    If MSComm1.InBufferCount <> 0 Then
        RxData() = MSComm1.Input
        Voltage = (RxData(0) * 4 + RxData(1)) * 5 / 1023
        Voltvalue.Text = Format$(Voltage, "#.00")
        VoltBar.Value = Voltage * 4096 / 5
    End If
End If
End Sub
